/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.envisional.test;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

/**
 *
 * @author adrian
 */

@Entity
@Table(
        name="DashboardColumn", 
        uniqueConstraints=
            @UniqueConstraint(columnNames={"columnNumber", "userDashboard_id"})
    )
public class DashboardColumn implements Serializable,Comparable<DashboardColumn> {

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private Long id;
	private int columnNumber;
	
	@OneToMany(mappedBy = "dashboardColumn", cascade=CascadeType.ALL)
	private List<DashboardWidget> widgets = new ArrayList<DashboardWidget>();


	public DashboardColumn() {
	}

	public DashboardColumn(Integer index) {
		this.columnNumber=index;
	}


	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public int getColumnNumber() {
		return columnNumber;
	}

	public void setColumnNumber(int columnNumber) {
		this.columnNumber = columnNumber;
	}

	public List<DashboardWidget> getWidgets() {
		return widgets;
	}

	public void setWidgets(List<DashboardWidget> widgets) {
		this.widgets = widgets;
	}


	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		final DashboardColumn other = (DashboardColumn) obj;
		if (this.columnNumber != other.columnNumber) {
			return false;
		}
		return true;
	}

	@Override
	public int hashCode() {
		int hash = 3;
		hash = 11 * hash + this.columnNumber;
		return hash;
	}

	@Override
	public String toString() {
		return "DashboardColumn{" + "columnNumber=" + columnNumber +'}';
	}

	@Override
	public int compareTo(DashboardColumn t) {
		return ((Integer)this.getColumnNumber()).compareTo(t.getColumnNumber());
	}
	
}
