/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.envisional.test;


import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

/**
 *
 * @author adrian
 */
@Entity
public class DashboardWidget implements Serializable, Comparable<DashboardWidget>{

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private long id;
	private String name;
	private Integer rowNumber;
	@ManyToOne
	private DashboardColumn dashboardColumn;
	@Column(nullable=false)
	private boolean hidden;

	public DashboardWidget() {
	}

	public DashboardWidget(long id) {
		this.id=id;
	}
	
	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public DashboardColumn getDashboardColumn() {
		return dashboardColumn;
	}

	public void setDashboardColumn(DashboardColumn dashboardColumn) {
		this.dashboardColumn = dashboardColumn;
	}

	public boolean isHidden() {
		return hidden;
	}

	public void setHidden(boolean hidden) {
		this.hidden = hidden;
	}

	public Integer getRowNumber() {
		return rowNumber;
	}

	public void setRowNumber(Integer rowNumber) {
		this.rowNumber = rowNumber;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		final DashboardWidget other = (DashboardWidget) obj;
		if ((this.name == null) ? (other.name != null) : !this.name.equals(other.name)) {
			return false;
		}

		return true;
	}

	@Override
	public int hashCode() {
		int hash = 7;
		hash = 59 * hash + (this.name != null ? this.name.hashCode() : 0);
		return hash;
	}

	

	@Override
	public int compareTo(DashboardWidget t) {
		return this.rowNumber.compareTo(t.rowNumber);
	}



}
